/*#####################################################################################
 *
 *   Title        : fruity_matrix.cpp
 *   Author       : Robert Bateman
 *   Date         : 23-Nov-2000
 *   Last Updated : 05-Dec-2000
 *
#####################################################################################*/

#include "./fruity_math.h"


// matrix = matrix * matrix

matrix operator*( const matrix& a , const matrix& b )

  {
    matrix n;
    // row 1
    n.r0_0  = a.r0_0*b.r0_0  + a.r0_1*b.r1_0  + a.r0_2*b.r2_0;
    n.r0_1  = a.r0_0*b.r0_1  + a.r0_1*b.r1_1  + a.r0_2*b.r2_1;
    n.r0_2  = a.r0_0*b.r0_2  + a.r0_1*b.r1_2  + a.r0_2*b.r2_2;
    n.r0_3  = a.r0_0*b.r0_3  + a.r0_1*b.r1_3  + a.r0_2*b.r2_3  + a.r0_3;

    n.r1_0  = a.r1_0*b.r0_0  + a.r1_1*b.r1_0  + a.r1_2*b.r2_0;
    n.r1_1  = a.r1_0*b.r0_1  + a.r1_1*b.r1_1  + a.r1_2*b.r2_1;
    n.r1_2  = a.r1_0*b.r0_2  + a.r1_1*b.r1_2  + a.r1_2*b.r2_2;
    n.r1_3  = a.r1_0*b.r0_3  + a.r1_1*b.r1_3  + a.r1_2*b.r2_3  + a.r1_3;

    n.r2_0  = a.r2_0*b.r0_0  + a.r2_1*b.r1_0  + a.r2_2*b.r2_0;
    n.r2_1  = a.r2_0*b.r0_1  + a.r2_1*b.r1_1  + a.r2_2*b.r2_1;
    n.r2_2  = a.r2_0*b.r0_2  + a.r2_1*b.r1_2  + a.r2_2*b.r2_2;
    n.r2_3  = a.r2_0*b.r0_3  + a.r2_1*b.r1_3  + a.r2_2*b.r2_3  + a.r2_3;

    return n;
  };

// cVector3f = matrix * cVector3f

cVector3f operator*(const matrix& m, const cVector3f& v)
  {
    cVector3f n;
    n.x  = (m.r0_0*v.x)  + (m.r0_1*v.y)  + (m.r0_2*v.z)  + (m.r0_3*v.w);
    n.y  = (m.r1_0*v.x)  + (m.r1_1*v.y)  + (m.r1_2*v.z)  + (m.r1_3*v.w);
    n.z  = (m.r2_0*v.x)  + (m.r2_1*v.y)  + (m.r2_2*v.z)  + (m.r2_3*v.w);
    n.w  = (m.r3_3*v.w);
    return n;
  };
