 /*##############################################################################
###
###  FRUITY GAME ENGINE VERSION 0.2     :     COPYRIGHT  ROB BATEMAN 15/NOV/00
###
###  WIN32.H  :  FED UP OF REMOVING OR INSERTING '#define WIN32' IN ALL FILES
###              WHEN SWITCHING BETWEEN WIN32 & IRIX
###
##############################################################################*/

/**
 ** Ammendment history:
 **
 ** 12/12/00 : Added extra texturing flags + default config file defs.
 **
 ** 08/12/00 : felt a need to increment the version history, got mocap data
 **            loading up today. Changed all old debug modes of old into new
 **            debug modes. Also added extra flags for speed critical
 **            implimentations, and editor based implimentations. Most of
 **            the new def's have not been implimented yet, but it gives me
 **            something to do over christmas.....
**/

//___________________________________________________________________________

#ifndef WIN_GL_INCLUDES
#define WIN_GL_INCLUDES

//___________________________________________________________________________





// !!!!!!!!!!!!!!!!!!!!!!!!!!! VERY IMPORTANT !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
// when ever you change any of these options and flags, be sure that you
// do a clean make. Changing these options will change the actual source code
// and class definitions that the engine uses, so the whole project will need
// to be re-compiled. This does however give it complete flexiblity for its
// usage, hence it kicks arse................................................





//___________________________________________________________________________
// ******************  win32 declaration + glut.h include  ******************
//___________________________________________________________________________

   #define WIN32

   #ifdef WIN32
     #include <GL/glut.h>
   #else
     #include "./glut.h"
   #endif

//___________________________________________________________________________
// ***********************  exception handling flags  ***********************
//___________________________________________________________________________

   // exception handling provides a number of functions for you, if you include
   //
   //                     "./fruity_exception.h"
   //
   // These deal with possible runtime errors associated with incorrect values
   // and data types being passed to the engine.
   //
   // One of the most useful is an error log. Calling the function..
   //
   //                    void ErrorLog( char *, char * );
   //
   // will add any comments into "./logs/runtime_error_log.txt". It can take
   // one or two strings (second doesnt have to be there) and put that in the
   // log file for you. This function is used by the fruity engine whenever
   // it encounters the exception. It will however only generate the log file
   // when "GENERATE_EXCEPTION_LOG" is defined. Otherwise this function is a
   // NULL call and will not affect the speed of the compiled code. It is
   // recommended that this option is left enabled as it will always be there
   // just in case a user of your program messes about with your filenames etc.
   //
   // The other functions that the eception handler provides are:
   //
   //            bool loadTexture( char *filename , GLuint& texObj );
   //
   // This will assign an unused texture object number to texObj, and load up
   // the file 'filename'. It can accept, *.tga's, *.bmp's & *.gif's. It will
   // test for the existance of the file you attempted to load, and return
   // false if not found. This is not considered a fatal exception, so will only
   // invoke an exit call if EXIT_ON_ALL_EXCEPTIONS is defined.
   //
   //
   //                    bool CheckMemory( void *Ptr );
   //
   // This function will test any allocated memory at the end of the pointer
   // 'Ptr'. If not successful, it will exit the program because it is considered
   // to be a fatal exception.
   //
   //
   //                    double divide_d( double a, double b );
   //                    double divide_f( float  a, float  b );
   //
   // This function will always ensure against a division by zero. It will return
   // a/b, but will always ensure that the division is do-able. If it isn't t will
   // replace the value of b with 0.000001, unless EXIT_ON_ALL_EXCEPTIONS is defined



   // exception handling flag. Having this commented out will
   // increase speed, but will not do any runtime error checking

   #define HANDLE_MY_EXCEPTIONS



   // With this commented out, The exception handler will only
   // Invoke the fatal error callback on fatal exceptions

   //#define EXIT_ON_ALL_EXCEPTIONS


   // generates "./logs/runtime_error_log.txt"

   #define GENERATE_EXCEPTION_LOG


   typedef unsigned int uint;


//___________________________________________________________________________

#endif

//___________________________________________________________________________
