// written by Gary Simmons for mr-gamemaker.com 2000

// Loads bitmaps of both 24 bit & 8 bit and stores them in any Surface Format.These functions work with surfaces that have 
// alpha channels and handles all color conversion.
//
// A bitmap is loaded like so:-
// 
// LPDIRECTDRAWSURFACE7 pTexture
// pTexture=MGM_LoadBitmap(pDirectDraw,pD3DDevice,"picture.bmp",pixelformat);
		   


#include <ddraw.h>
#include <d3d.h>
#include <d3dtypes.h>
#include "MGMBitmaps.h"

LPDIRECTDRAWSURFACE7 MGM_CreateBitmap (LPDIRECTDRAW7 lpDD,LPDIRECT3DDEVICE7 lpDevice,WORD wid,WORD hig,DDPIXELFORMAT pf)
{
DDSURFACEDESC2 ddsd;
D3DDEVICEDESC7 ddDesc;
LPDIRECTDRAWSURFACE7 surface;
memset(&ddsd,0,sizeof(DDSURFACEDESC2));
lpDevice->GetCaps(&ddDesc);

ddsd.dwSize=sizeof(ddsd);
ddsd.dwFlags=DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH | DDSD_PIXELFORMAT ;
ddsd.ddsCaps.dwCaps= DDSCAPS_TEXTURE;
ddsd.dwHeight=hig;
ddsd.dwWidth=wid;
ddsd.ddpfPixelFormat=pf;


if (ddDesc.deviceGUID==IID_IDirect3DHALDevice || ddDesc.deviceGUID==IID_IDirect3DTnLHalDevice)
{
ddsd.ddsCaps.dwCaps2=DDSCAPS2_TEXTUREMANAGE;
}
else
{
ddsd.ddsCaps.dwCaps |= DDSCAPS_SYSTEMMEMORY;
}

if (ddDesc.dpcTriCaps.dwTextureCaps & D3DPTEXTURECAPS_POW2 )
{
for (ddsd.dwWidth=1; wid>ddsd.dwWidth; ddsd.dwWidth<<=1);
for (ddsd.dwHeight=1; wid>ddsd.dwHeight; ddsd.dwHeight<<=1);
}
if (ddDesc.dpcTriCaps.dwTextureCaps & D3DPTEXTURECAPS_SQUAREONLY)
{
if (ddsd.dwWidth>ddsd.dwHeight )ddsd.dwHeight=ddsd.dwWidth;
else
ddsd.dwWidth=ddsd.dwHeight;
}

lpDD->CreateSurface(&ddsd, &surface, NULL);
surface->Restore();
return surface;
}











LPDIRECTDRAWSURFACE7 MGM_LoadBitmap(LPDIRECTDRAW7 lpDD,LPDIRECT3DDEVICE7 lpDevice,char * string,DDPIXELFORMAT surfaceformat)
{
LPDIRECTDRAWSURFACE7 surface;
HBITMAP hbitmap=NULL;
BITMAP bitmapinfo;
int BitmapWidth,BitmapHeight;
float red;
float green;
float blue;
float alpha=1; 
DWORD BitmapColorDepth=0;
RGBQUAD table[256];
HDC dc;

hbitmap=(HBITMAP)LoadImage(NULL, string, IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE|LR_CREATEDIBSECTION);
if (hbitmap==NULL) return NULL;
GetObject(hbitmap,sizeof(BITMAP),(void *)&bitmapinfo );
BitmapWidth=bitmapinfo.bmWidth;
BitmapHeight=bitmapinfo.bmHeight;
BitmapColorDepth=bitmapinfo.bmBitsPixel;
surface=MGM_CreateBitmap(lpDD,lpDevice,BitmapWidth,BitmapHeight,surfaceformat);
DDSURFACEDESC2 desc;
ZeroMemory( &desc, sizeof( desc ));
desc.dwSize = sizeof( desc ); 
BYTE *BitmapByte=(BYTE *)bitmapinfo.bmBits;
surface->Lock(NULL,&desc,DDLOCK_WAIT,NULL);
DWORD mode=desc.ddpfPixelFormat.dwRGBBitCount;
DWORD * SurfPtr=NULL;
WORD * Sixteenbit_SurfPtr=NULL;
DWORD AlphaMask = ( DWORD )desc.ddpfPixelFormat.dwRGBAlphaBitMask;

if (BitmapColorDepth==24)
{ 

if (mode==32) 
{
for( DWORD y =desc.dwHeight-1;y>0; y-- )
{ 
SurfPtr = ( DWORD* )(( BYTE* )desc.lpSurface + y * desc.lPitch ); 
for( DWORD x=0;x != desc.dwWidth; x++ ) 
{ 
blue=*BitmapByte/255.0f;
BitmapByte++;
green=*BitmapByte/255.0f;
BitmapByte++;
red=*BitmapByte/255.0f;
BitmapByte++;
DWORD color =(((DWORD)(AlphaMask*alpha)) & AlphaMask)+ ( ((DWORD)(desc.ddpfPixelFormat.dwRBitMask*red)) & desc.ddpfPixelFormat.dwRBitMask) + ( ((DWORD)(desc.ddpfPixelFormat.dwGBitMask*green)) & desc.ddpfPixelFormat.dwGBitMask) + ( ((DWORD)(desc.ddpfPixelFormat.dwBBitMask*blue)) & desc.ddpfPixelFormat.dwBBitMask); 
*SurfPtr=color;
SurfPtr++; 
} 
} 
}

else

if (mode==16)//we want a 16 bit surface
{
for( DWORD y =desc.dwHeight-1;y>0; y-- )
{ 
Sixteenbit_SurfPtr = ( WORD* )(( BYTE* )desc.lpSurface + y * desc.lPitch ); 
for( DWORD x=0;x != desc.dwWidth; x++ ) 
{ 
blue=*BitmapByte/255.0f;
BitmapByte++;
green=*BitmapByte/255.0f;
BitmapByte++;
red=*BitmapByte/255.0f;
BitmapByte++;
DWORD color =(((DWORD)(AlphaMask*alpha)) & AlphaMask)+ ( ((DWORD)(desc.ddpfPixelFormat.dwRBitMask*red)) & desc.ddpfPixelFormat.dwRBitMask) + ( ((DWORD)(desc.ddpfPixelFormat.dwGBitMask*green)) & desc.ddpfPixelFormat.dwGBitMask) + ( ((DWORD)(desc.ddpfPixelFormat.dwBBitMask*blue)) & desc.ddpfPixelFormat.dwBBitMask); 
*Sixteenbit_SurfPtr=(WORD)color;
Sixteenbit_SurfPtr++; 
} 
} 
}
}

else

if (BitmapColorDepth==8)
{
dc=CreateCompatibleDC(NULL);
SelectObject(dc,hbitmap);
GetDIBColorTable(dc,0,256,&table[0]);
BYTE index=0;
if (mode==32)
{
for( DWORD y =desc.dwHeight-1;y>0; y-- )
{ 
SurfPtr = ( DWORD* )(( BYTE* )desc.lpSurface + y * desc.lPitch );
for( DWORD x=0;x != desc.dwWidth; x++ ) 
{ 
index=*BitmapByte;
blue=table[index].rgbBlue/255.0f;
green=table[index].rgbGreen/255.0f;
red=table[index].rgbRed/255.0f;
BitmapByte++;

DWORD color =(((DWORD)(AlphaMask*alpha)) & AlphaMask)+ ( ((DWORD)(desc.ddpfPixelFormat.dwRBitMask*red)) & desc.ddpfPixelFormat.dwRBitMask) + ( ((DWORD)(desc.ddpfPixelFormat.dwGBitMask*green)) & desc.ddpfPixelFormat.dwGBitMask) + ( ((DWORD)(desc.ddpfPixelFormat.dwBBitMask*blue)) & desc.ddpfPixelFormat.dwBBitMask); 
*SurfPtr=color;
SurfPtr++; 
} 
} 
}

else

if (mode==16)
{

for( DWORD y =desc.dwHeight-1;y>0; y-- )
{ 
Sixteenbit_SurfPtr = ( WORD* )(( BYTE* )desc.lpSurface + y * desc.lPitch ); 
for( DWORD x=0;x!= desc.dwWidth; x++ ) 
 { 
index=*BitmapByte;
blue=table[index].rgbBlue/255.0f;
green=table[index].rgbGreen/255.0f;
red=table[index].rgbRed/255.0f;
BitmapByte++;

DWORD color =(((DWORD)(AlphaMask*alpha)) & AlphaMask)+ ( ((DWORD)(desc.ddpfPixelFormat.dwRBitMask*red)) & desc.ddpfPixelFormat.dwRBitMask) + ( ((DWORD)(desc.ddpfPixelFormat.dwGBitMask*green)) & desc.ddpfPixelFormat.dwGBitMask) + ( ((DWORD)(desc.ddpfPixelFormat.dwBBitMask*blue)) & desc.ddpfPixelFormat.dwBBitMask); 
*Sixteenbit_SurfPtr=(WORD)color;
Sixteenbit_SurfPtr++; 
} 
} 
}
}
DeleteDC(dc); 

surface->Unlock( NULL );
DeleteObject(hbitmap); 
return surface;
}







