/*==========================================================================
 *
 * Cheep & Cheerful BSP Compiler and Renderer written for www.mr-gamemaker.com
 * written by Gary Simmons.
 *
 *
 * Any of the code in this example may be used in your own programs although mr-gamemaker.com would appreciate a mention
 * whenever possible if you have found us to be of any help.
 *
 * you need to link in d3dmath.cpp and d3dutil.cpp from the D3D framework (this is supplied with the Dx7 sdk)
 ***************************************************************************/
#define INITGUID     
#define D3D_OVERLOADS
#define NAME "BSP TUTORIAL"
#define TITLE "BSP  Tutorial"

#define WIN32_LEAN_AND_MEAN

#include <ddraw.h>					
#include <d3d.h>
#include <d3dtypes.h>
#include "d3dutil.h"
#include "d3dmath.h"
#include "mgmbitmaps.h"
int rendering=1;


BYTE BSPMAP []={0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
				0,0,2,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,
				0,2,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,
				1,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,0,1,
				0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,1,
				0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,
				0,1,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,3,1,
				0,2,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,1,
				0,1,0,0,0,0,1,2,0,0,0,1,0,0,0,1,0,0,0,1,
				0,1,0,0,0,1,2,0,0,0,0,1,1,0,0,0,0,0,0,1,
				0,1,0,0,0,1,0,0,0,0,0,3,1,0,0,0,0,0,0,1,
				0,1,0,1,1,2,0,0,0,0,0,0,1,0,0,0,0,0,0,1,
				1,2,0,0,0,0,0,0,1,0,0,0,1,1,1,1,0,0,0,1,  /* 1=cube 2=/ 3=\	  */
				1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,1,2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,1,1,1,1,0,1,0,0,0,0,0,1,1,1,1,1,1,1,1,
				0,0,0,1,1,0,1,0,0,0,0,1,1,1,1,1,1,1,1,1,
				0,0,2,0,0,0,1,0,0,1,0,3,0,0,0,0,0,0,0,0,
				0,2,0,0,0,0,1,0,0,1,0,0,3,0,0,0,0,0,0,0,
				1,0,0,0,0,0,1,0,0,1,0,0,0,1,1,1,1,1,0,1,
				0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,0,1,
				0,1,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,1,1,1,
				0,1,1,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,3,1,
				0,2,0,0,0,0,0,1,0,1,1,1,0,0,0,1,0,0,0,1,
				1,0,0,0,0,0,0,1,0,0,3,1,0,0,0,1,0,0,0,1,
				0,1,0,0,0,0,1,2,0,0,0,1,0,0,0,1,0,0,0,1,
				0,1,0,0,0,1,2,0,0,0,0,1,1,0,0,0,0,0,0,1,
				0,1,0,0,0,1,0,0,0,0,0,3,1,0,0,0,0,0,0,1,
				0,1,0,1,1,2,0,0,0,0,0,0,1,0,0,0,0,0,0,1,
				1,2,0,0,0,0,0,0,1,0,0,0,1,1,1,1,0,0,0,1,  /* 1=cube 2=/ 3=\	  */
				1,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,1,2,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,
				1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1};

float Yaw=0.0;
const int CP_FRONT=1001;
const int CP_BACK =1002;
const int CP_ONPLANE=1003;
const int CP_SPANNING=1004;
int LEFTKEY=0,RIGHTKEY=0,UPKEY=0,DOWNKEY=0;;

int quit=0;



D3DVECTOR look_vector(0,0,1);
D3DVECTOR up_vector(0,1,0);
D3DVECTOR right_vector(1,0,0);
D3DVECTOR position(0,1,5);
						  



struct POLYGON 
{
D3DLVERTEX VertexList[10];
D3DVECTOR Normal;
WORD NumberOfVertices;
WORD NumberOfIndices;
WORD Indices[30];
POLYGON * Next;
};



struct NODE 
{
POLYGON * Splitter;
NODE * Front;
NODE * Back;
BOOL IsLeaf;
BOOL IsSolid;
};



D3DLVERTEX VertexList[3*5];
POLYGON * PolygonList;
NODE * BSPTreeRootNode;




LRESULT CALLBACK WindowProc(HWND hWnd, unsigned uMsg, WPARAM wParam, LPARAM lParam);
BOOL init_ddraw(HWND hWnd);

POLYGON * AddPolygon(POLYGON* Parent,D3DLVERTEX *Vertices,WORD NumberOfVerts);
void SplitPolygon(POLYGON *Poly,POLYGON *Plane,POLYGON *FrontSplit,POLYGON *BackSplit);
void BuildBspTree(NODE * CurrentNode,POLYGON * PolyList);
void WalkBspTree(NODE *Node,D3DVECTOR *pos);
void InitPolygons(void);
void renderframe(void);
int ClassifyPoly(POLYGON *plane,POLYGON * Poly);
int ClassifyPoint(D3DVECTOR *pos,POLYGON * Plane);
bool Get_Intersect (D3DVECTOR *linestart,D3DVECTOR *lineend,D3DVECTOR *vertex,D3DVECTOR *normal,D3DVECTOR * intersection, float *percentage);
void UpdateViewpos(void);
bool LineOfSight (D3DVECTOR *Start,D3DVECTOR *End, NODE *Node) ;
void DeleteBSPTree(NODE *Node) ;

POLYGON * SelectBestSplitter(POLYGON *PolyList);



HWND                hwnd;
HINSTANCE hInst;
LPDIRECTDRAW7            lpDD;           // DirectDraw object
LPDIRECTDRAWSURFACE7 lpDDSPrimary=NULL,lpDDSBack=NULL,lpTextureSurface=NULL;
LPDIRECT3D7 lpD3D;
LPDIRECT3DDEVICE7 lpDevice;





















void BuildBspTree(NODE * CurrentNode,POLYGON * PolyList)
{

POLYGON *polyTest=NULL;
POLYGON *FrontList=NULL;
POLYGON *BackList=NULL;
POLYGON *NextPolygon=NULL;
POLYGON *FrontSplit=NULL;
POLYGON *BackSplit=NULL;
D3DVECTOR vec1,vec2;



CurrentNode->Splitter=SelectBestSplitter(PolyList);
polyTest=PolyList;


while (polyTest!=NULL)
{
NextPolygon=polyTest->Next;// remember because polytest->Next will be altered
if (polyTest!=CurrentNode->Splitter)
{

switch (ClassifyPoly(CurrentNode->Splitter,polyTest))
{



case CP_FRONT:
polyTest->Next=FrontList;
FrontList=polyTest;		
	break;

case CP_BACK:
polyTest->Next=BackList;
BackList=polyTest;	
	break;


case CP_SPANNING:
	  
	FrontSplit=new POLYGON;
	BackSplit=new POLYGON;
	ZeroMemory(FrontSplit,sizeof(POLYGON));
	ZeroMemory(BackSplit,sizeof(POLYGON));
	SplitPolygon(polyTest,CurrentNode->Splitter,FrontSplit,BackSplit);
    delete polyTest;
	FrontSplit->Next=FrontList;
	FrontList=FrontSplit;
	BackSplit->Next=BackList;
	BackList=BackSplit;

break;
default:
	break;

}
}// end if polypoint!=CurrentNodesplitter

polyTest=NextPolygon;
}// end while loop

if (FrontList==NULL)
{
	
NODE *leafnode=new NODE;
ZeroMemory(leafnode,sizeof(leafnode));
leafnode->IsLeaf=true;
leafnode->IsSolid=false;	
leafnode->Front=NULL;
leafnode->Back=NULL;
leafnode->Splitter=NULL;
CurrentNode->Front=leafnode;
}
else
{
NODE * newnode=new NODE;
ZeroMemory(newnode,sizeof(newnode));
newnode->IsLeaf=false;
CurrentNode->Front=newnode;
BuildBspTree(newnode,FrontList);
}

if (BackList==NULL)
{
NODE *leafnode=new NODE;
ZeroMemory(leafnode,sizeof(leafnode));
leafnode->IsLeaf=true;
leafnode->IsSolid=true;		
leafnode->Front=NULL;
leafnode->Back=NULL;
leafnode->Splitter=NULL;
CurrentNode->Back=leafnode;;
}
else
{
NODE * newnode=new NODE;
ZeroMemory(newnode,sizeof(newnode));
newnode->IsLeaf=false;
CurrentNode->Back=newnode;
BuildBspTree(newnode,BackList);
}

}// end function

























int ClassifyPoly(POLYGON *Plane,POLYGON * Poly)
{
int Infront=0;
int Behind=0;
int OnPlane=0;
float result;
D3DVECTOR *vec1=(D3DVECTOR *)&Plane->VertexList[0];

for (int a=0;a<Poly->NumberOfVertices;a++)

{
D3DVECTOR *vec2=(D3DVECTOR *)&Poly->VertexList[a];
D3DVECTOR Direction=(*vec1)-(*vec2);
result=DotProduct(Direction,Plane->Normal);

if (result>0.0001) 
{
Behind++;
}
else
if (result<-0.0001)
{
Infront++;
}
else
{
OnPlane++;
Infront++;
Behind++;
}
}

if (OnPlane==Poly->NumberOfVertices) return CP_FRONT;
if (Behind==Poly->NumberOfVertices) return CP_BACK;
if (Infront==Poly->NumberOfVertices) return CP_FRONT;
return CP_SPANNING;
}











int ClassifyPoint(D3DVECTOR *pos,POLYGON * Plane)
{
float result;
D3DVECTOR *vec1=(D3DVECTOR *)&Plane->VertexList[0];
D3DVECTOR Direction=(*vec1)-(*pos);
result=DotProduct(Direction,Plane->Normal);
if (result<-0.001) return CP_FRONT;
if (result>0.001) return CP_BACK;

return CP_ONPLANE;
}






























void WalkBspTree(NODE *Node,D3DVECTOR *pos)
{
if (Node->IsLeaf==true) return;

int result=ClassifyPoint(pos,Node->Splitter);
if (result==CP_FRONT)
{

	if (Node->Back!=NULL) WalkBspTree(Node->Back,pos);
lpDevice->DrawIndexedPrimitive(D3DPT_TRIANGLELIST,D3DFVF_LVERTEX,&Node->Splitter->VertexList[0],Node->Splitter->NumberOfVertices,&Node->Splitter->Indices[0],Node->Splitter->NumberOfIndices,NULL);

if (Node->Front!=NULL) WalkBspTree(Node->Front,pos);
return ;
}





// this happens if we are at back or on plane
if (Node->Front!=NULL) WalkBspTree(Node->Front,pos);

  
if (Node->Back!=NULL) WalkBspTree(Node->Back,pos);
return;




}








































void InitPolygons(void)
{

D3DLVERTEX VERTLIST[4][4];
PolygonList=NULL;
POLYGON *child=NULL;
int direction[4];


for (int y=0;y<40;y++)
{
for (int x=0;x<20;x++)
{
ZeroMemory(direction,sizeof(int)*4);
int offset=(y*20)+x;
////////////////////////////////////////

 if (BSPMAP[offset]!=0)
 {
if (BSPMAP[offset]==2)
{	
VERTLIST[0][0]=D3DLVERTEX(D3DVECTOR(x-10.5f,3.0f,(20.0f-y)-0.5f),RGB_MAKE( 255, 255, 255),0,0,0);
VERTLIST[0][1]=D3DLVERTEX(D3DVECTOR(x-9.5f,3.0f,(20.0f-y)+0.5f),RGB_MAKE( 255, 255, 255),0,1,0);
VERTLIST[0][2]=D3DLVERTEX(D3DVECTOR(x-9.5f,0.0f,(20.0f-y)+0.5f),RGB_MAKE( 255, 255, 255),0,1,1);
VERTLIST[0][3]=D3DLVERTEX(D3DVECTOR(x-10.5f,0.0f,(20.0f-y)-0.5f),RGB_MAKE( 255, 255, 255),0,0,1);
direction[0]=1;
}
 
if (BSPMAP[offset]==3)
{	
VERTLIST[0][0]=D3DLVERTEX(D3DVECTOR(x-10.5f,3.0f,(20.0f-y)+0.5f),RGB_MAKE( 255, 255, 255),0,0,0);
VERTLIST[0][1]=D3DLVERTEX(D3DVECTOR(x-9.5f,3.0f,(20.0f-y)-0.5f),RGB_MAKE( 255, 255, 255),0,1,0);
VERTLIST[0][2]=D3DLVERTEX(D3DVECTOR(x-9.5f,0.0f,(20.0f-y)-0.5f),RGB_MAKE( 255, 255, 255),0,1,1);
VERTLIST[0][3]=D3DLVERTEX(D3DVECTOR(x-10.5f,0.0f,(20.0f-y)+0.5f),RGB_MAKE( 255, 255, 255),0,0,1);
direction[0]=1;
}	
	
if (BSPMAP[offset]==1)
{
if (x>0)
{
if (BSPMAP[offset-1]==0)
{
VERTLIST[0][0]=D3DLVERTEX(D3DVECTOR(x-10.5f,3.0f,(20.0f-y)+0.5f),RGB_MAKE(255,255,255),0,0,0);
VERTLIST[0][1]=D3DLVERTEX(D3DVECTOR(x-10.5f,3.0f,(20.0f-y)-0.5f),RGB_MAKE(255,255,255),0,1,0);
VERTLIST[0][2]=D3DLVERTEX(D3DVECTOR(x-10.5f,0.0f,(20.0f-y)-0.5f),RGB_MAKE(255,255,255),0,1,1);
VERTLIST[0][3]=D3DLVERTEX(D3DVECTOR(x-10.5f,0.0f,(20.0f-y)+0.5f),RGB_MAKE(255,255,255),0,0,1);
direction[0]=1;
}

}
  


if (x<19)
{
if (BSPMAP[offset+1]==0)
{
VERTLIST[1][0]=D3DLVERTEX(D3DVECTOR(x-9.5f,3.0f,(20.0f-y)-0.5f),RGB_MAKE(255,255,255),0,0,0);
VERTLIST[1][1]=D3DLVERTEX(D3DVECTOR(x-9.5f,3.0f,(20.0f-y)+0.5f),RGB_MAKE(255,255,255),0,1,0);
VERTLIST[1][2]=D3DLVERTEX(D3DVECTOR(x-9.5f,0.0f,(20.0f-y)+0.5f),RGB_MAKE(255,255,255),0,1,1);
VERTLIST[1][3]=D3DLVERTEX(D3DVECTOR(x-9.5f,0.0f,(20.0f-y)-0.5f),RGB_MAKE(255,255,255),0,0,1);
direction[1]=1;
}
}
	

if (y>0)
{
if (BSPMAP[offset-20]==0)
{
VERTLIST[2][0]=D3DLVERTEX(D3DVECTOR(x-9.5f,3.0f,(20.0f-y)+0.5f),RGB_MAKE(255,255,255),0,0,0);
VERTLIST[2][1]=D3DLVERTEX(D3DVECTOR(x-10.5f,3.0f,(20.0f-y)+0.5f),RGB_MAKE(255,255,255),0,1,0);
VERTLIST[2][2]=D3DLVERTEX(D3DVECTOR(x-10.5f,0.0f,(20.0f-y)+0.5f),RGB_MAKE(255,255,255),0,1,1);
VERTLIST[2][3]=D3DLVERTEX(D3DVECTOR(x-9.5f,0.0f,(20.0f-y)+0.5f),RGB_MAKE( 255, 255, 255),0,0,1);
direction[2]=1;;
}
}

if(y<39)
{	
if (BSPMAP[offset+20]==0)
{
VERTLIST[3][0]=D3DLVERTEX(D3DVECTOR(x-10.5f,3.0f,(20.0f-y)-0.5f),RGB_MAKE(255,255,255),0,0,0);
VERTLIST[3][1]=D3DLVERTEX(D3DVECTOR(x-9.5f,3.0f,(20.0f-y)-0.5f),RGB_MAKE(255, 255, 255),0,1,0);
VERTLIST[3][2]=D3DLVERTEX(D3DVECTOR(x-9.5f,0.0f,(20.0f-y)-0.5f),RGB_MAKE( 255, 255, 255),0,1,1);
VERTLIST[3][3]=D3DLVERTEX(D3DVECTOR(x-10.5f,0.0f,(20.0f-y)-0.5f),RGB_MAKE( 255, 255, 255),0,0,1);
direction[3]=1;;
}
}	  
}// end for if offset==1
	  

for (int a=0;a<4;a++)
{////
if (direction[a]!=0)
{//
if (PolygonList==NULL)
{
PolygonList=AddPolygon(NULL,&VERTLIST[a][0],4);
child=PolygonList;
}
else
{
child=AddPolygon(child,&VERTLIST[a][0],4);
}
}//

}////

 }// end for if offset!=0
/////////////////////////////////////

}
}



  BSPTreeRootNode=new NODE;
BuildBspTree(BSPTreeRootNode,PolygonList);
}


















void renderframe(void)
{

UpdateViewpos();
lpDevice->Clear(0,NULL,D3DCLEAR_TARGET,0,0.0f,0);
lpDevice->BeginScene();
WalkBspTree(BSPTreeRootNode,(D3DVECTOR *)&position);
lpDevice->EndScene();
lpDDSPrimary->Flip(0,DDFLIP_WAIT);
}







































































































































 static BOOL doInit( HINSTANCE hInstance, int nCmdShow )
{
    

		
    WNDCLASS            wc;
   
    // Set up and register window class
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = (WNDPROC) WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = sizeof(DWORD);
    wc.hInstance = hInstance;
    wc.hIcon = NULL;
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH) GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName = NULL;
    wc.lpszClassName = "my window";
    
	if (!RegisterClass(&wc)) 
	{
		return FALSE;
	}

    // Get dimensions of display

    int ScreenWidth = GetSystemMetrics(SM_CXSCREEN);
    int ScreenHeight = GetSystemMetrics(SM_CYSCREEN);

    // Create a window and display

	HWND hWnd;
    hWnd = CreateWindow("my window",							// class
                        "BSP me baby",							// caption
						WS_VISIBLE|WS_POPUP,				// style 
						0,									// left
						0,									// top
						ScreenWidth,						// width
						ScreenHeight,						// height
                        NULL,								// parent window
                        NULL,								// menu 
                        hInstance,							// instance
                        NULL);								// parms
    if (!hWnd) {
        return FALSE;
				}
    
	ShowWindow(hWnd, nCmdShow);
    UpdateWindow(hWnd);

	// initialze DirectDraw
init_ddraw(hWnd);
InitPolygons();

	return TRUE;
	
} /* doInit */
























 

 
 
 
 
 
 
 
 int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                        LPSTR lpCmdLine, int nCmdShow)
{   
	
	MSG         msg;
	hInst=hInstance;
    hPrevInstance = hPrevInstance;
    
	if( !doInit( hInst, nCmdShow ) )
    {
        return FALSE;
    }

 
    // Now we're ready to recieve and process Windows messages.

    BOOL bGotMsg;
    
	
while( quit!=1  ){
    while (bGotMsg = PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ))
			{
        
       
			TranslateMessage( &msg );
            DispatchMessage( &msg );
        } 
			
if (rendering==1)
{			

if (LEFTKEY==1)
{
Yaw=+0.05f;
}
if (RIGHTKEY==1)
{
Yaw=-0.05f;	
}
if (DOWNKEY==1)
{
  D3DVECTOR END=position-(look_vector*1.5)	;
	 if (LineOfSight( &position,&END,BSPTreeRootNode)==true) position-=0.1f*look_vector;	

}

if (UPKEY==1)
{
	D3DVECTOR END=position+(look_vector*1.5)	;
	 if (LineOfSight( &position,&END,BSPTreeRootNode)==true) position+=0.1f*look_vector;	
}	
	renderframe();
}		
    
			}
	// return final message

    return msg.wParam;
}



 
 
 
 
 
 
 


















 
 
 
 
 
 LRESULT CALLBACK 
WindowProc(HWND hWnd, unsigned uMsg, WPARAM wParam, LPARAM lParam)
{

	switch (uMsg)	 // ropey keyboard handling but please forgive me
    {

		case WM_DESTROY:
            rendering=0;
			DeleteBSPTree(BSPTreeRootNode);
			lpTextureSurface->Release();
			lpDevice->Release();
			lpDDSBack->Release();
			lpDDSPrimary->Release();
			lpD3D->Release();
			lpDD->Release();
			PostQuitMessage(0);
            break;

	    case WM_KEYDOWN: 
	        switch (wParam)    
			{ 
			
			case VK_LEFT:
				LEFTKEY=1;
				break;
			
			case VK_RIGHT:
				RIGHTKEY=1;
				break;

			case VK_UP:
			UPKEY=1;
				break;
			
			
			case VK_DOWN:
				DOWNKEY=1;
				break;
			
			}
			break;

       
			
		case WM_KEYUP: 
	        switch (wParam) { 
			
			
			
			case VK_LEFT:
				LEFTKEY=0;
				break;
			
			case VK_RIGHT:
				RIGHTKEY=0;
				break;

			case VK_UP:
			    UPKEY=0;
				break;
			case VK_DOWN:
				DOWNKEY=0;
				break;
			
			
			case VK_ESCAPE:
				// exit the program on escape
				quit=1;
				
				DestroyWindow(hWnd);
				break;
			}
			break;
	
			
			
			default:
            return DefWindowProc(hWnd, uMsg, wParam, lParam);
    }
	return 0L;
}


















BOOL init_ddraw(HWND hWnd)
{
  
	//Create DirectDraw7 & Direct3d7 Objects

  DirectDrawCreateEx(NULL, (void **) &lpDD, IID_IDirectDraw7, NULL);
  lpDD->QueryInterface(IID_IDirect3D7,(LPVOID *)&lpD3D);	
  lpDD->SetCooperativeLevel(hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
	lpDD->SetDisplayMode( 640, 480, 16, 0, 0);

	//Create primary and secindary surfaces
	DDSURFACEDESC2 ddsd;
	ZeroMemory(&ddsd,sizeof(ddsd));
    ddsd.dwSize = sizeof( ddsd );
    ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
                          DDSCAPS_FLIP | DDSCAPS_3DDEVICE |
                          DDSCAPS_COMPLEX;
    ddsd.dwBackBufferCount = 1;
    lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );

	DDSCAPS2 ddscaps;
	ZeroMemory(&ddscaps,sizeof(ddscaps));
	ddscaps.dwCaps=DDSCAPS_BACKBUFFER;
	lpDDSPrimary->GetAttachedSurface(&ddscaps,&lpDDSBack);

	// create device
	
if (lpD3D->CreateDevice(IID_IDirect3DHALDevice	,lpDDSBack,&lpDevice)!=D3D_OK)
{
lpD3D->CreateDevice(IID_IDirect3DRGBDevice	,lpDDSBack,&lpDevice);	
	
}
	
// set viewport
D3DVIEWPORT7 view;
	view.dwX=0;
	view.dwY=0; 
	view.dwWidth=640;
	view.dwHeight=480; 
	view.dvMinZ=0.0f;
	view.dvMaxZ=1.0f;
	lpDevice->SetViewport(&view);

	// Set projection matrix
	D3DMATRIX proj_m;
    D3DUtil_SetProjectionMatrix(proj_m, 1.0f,1.33333f,0.3f, 1500.0f );	
	lpDevice->SetTransform(D3DTRANSFORMSTATE_PROJECTION,&proj_m);	
	lpDevice->SetRenderState(D3DRENDERSTATE_AMBIENT,RGB_MAKE(255,255,255));
	lpDevice->SetRenderState(D3DRENDERSTATE_TEXTUREPERSPECTIVE,true);	

//load in textures
DDPIXELFORMAT ddpf;
ZeroMemory(&ddpf,sizeof(ddpf));
ddpf.dwSize=sizeof(ddpf);
lpDDSBack->GetPixelFormat(&ddpf);
lpTextureSurface=MGM_LoadBitmap(lpDD,lpDevice,"wall2.bmp",ddpf); 

lpDevice->SetTexture(0,lpTextureSurface);
lpDevice->SetTextureStageState(0,D3DTSS_MAGFILTER,D3DTFG_LINEAR);
lpDevice->SetTextureStageState(0,D3DTSS_MINFILTER,D3DTFG_LINEAR);
lpDevice->SetRenderState(D3DRENDERSTATE_LIGHTING,false);  // we are using prelit vertices


	
	return TRUE;
}
















































bool Get_Intersect (D3DVECTOR *linestart,D3DVECTOR *lineend,D3DVECTOR *vertex,D3DVECTOR *normal,D3DVECTOR * intersection, float *percentage)

{
D3DVECTOR direction,L1;
float linelength,dist_from_plane;

direction.x=lineend->x-linestart->x;
direction.y=lineend->y-linestart->y;
direction.z=lineend->z-linestart->z;


  linelength=DotProduct(direction,*normal);
if (fabsf(linelength)<0.0001) 
{
	return false; 
}

L1.x=vertex->x-linestart->x;
L1.y=vertex->y-linestart->y;
L1.z=vertex->z-linestart->z;



  dist_from_plane=DotProduct(L1,*normal);

*percentage=dist_from_plane/linelength; // How far from Linestart , intersection is as a percentage of 0 to 1 

if (*percentage<0.0f) // The plane is behind the start of the line
{
return false;
}

else

if (*percentage>1.0f) // The line does not reach the plane
{
return false;
}

else 

intersection->x=linestart->x+direction.x*(*percentage);// add the percentage of the line to line start
intersection->y=linestart->y+direction.y*(*percentage);
intersection->z=linestart->z+direction.z*(*percentage);
return true;
}





















































void SplitPolygon(POLYGON *Poly,POLYGON *Plane,POLYGON *FrontSplit,POLYGON *BackSplit)
{

D3DLVERTEX FrontList[20],BackList[20],FirstVertex;
D3DVECTOR PlaneNormal,IntersectPoint,PointOnPlane,PointA,PointB;
WORD FrontCounter=0,BackCounter=0,loop=0,CurrentVertex=0;
float percent;	// used for return storage of percentage

// Find any vertex on the plane to use later in plane intersect routine
PointOnPlane=*(D3DVECTOR *)&Plane->VertexList[0];



// first we find out if the first vertex belongs in front or back list
FirstVertex=Poly->VertexList[0];

switch (ClassifyPoint( (D3DVECTOR *)&FirstVertex,Plane))
{
case CP_FRONT:
	FrontList[FrontCounter++]=FirstVertex;
	break;
case CP_BACK:
	BackList[BackCounter++]=FirstVertex;
	break;

case CP_ONPLANE:
BackList[BackCounter++]=FirstVertex;
FrontList[FrontCounter++]=FirstVertex;
	break;
default:
	PostQuitMessage(0);;
}

for (loop=1;loop<Poly->NumberOfVertices+1;loop++)
{

if (loop==Poly->NumberOfVertices) 
{
CurrentVertex=0;
}
else
{
CurrentVertex=loop;
}
PointA=*(D3DVECTOR *)&Poly->VertexList[loop-1];
PointB=*(D3DVECTOR *)&Poly->VertexList[CurrentVertex];


PlaneNormal=Plane->Normal;

int Result=ClassifyPoint(&PointB,Plane);
if (Result==CP_ONPLANE)
{
BackList[BackCounter++]=Poly->VertexList[CurrentVertex];
FrontList[FrontCounter++]=Poly->VertexList[CurrentVertex];
}
else
{
if (Get_Intersect(&PointA,&PointB,&PointOnPlane,&PlaneNormal,&IntersectPoint, &percent)==true)
			{

	// create new vertex and calculate new texture coordinate
	float deltax,deltay,texx,texy;
	deltax=Poly->VertexList[CurrentVertex].tu-Poly->VertexList[loop-1].tu;
	deltay=Poly->VertexList[CurrentVertex].tv-Poly->VertexList[loop-1].tv;
	texx=Poly->VertexList[loop-1].tu+(deltax*percent);
	texy=Poly->VertexList[loop-1].tv+(deltay*percent);
	 D3DLVERTEX copy=D3DLVERTEX(IntersectPoint,RGB_MAKE(255,255,255),0,texx,texy);
	//
	if (Result==CP_FRONT )
				{
					BackList[BackCounter++]=copy;			
					FrontList[FrontCounter++]=copy;
					if (CurrentVertex!=0)
					{
					FrontList[FrontCounter++]=Poly->VertexList[CurrentVertex];
					}
					}	


	if (Result==CP_BACK)
				{
					FrontList[FrontCounter++]=copy;
					BackList[BackCounter++]=copy;		
				    
					if (CurrentVertex!=0)
					{
					BackList[BackCounter++]=Poly->VertexList[CurrentVertex];
					}
					}			

}// end get intersect


else
{


if (Result==CP_FRONT)
{
	if (CurrentVertex!=0)
	{
 FrontList[FrontCounter++]=Poly->VertexList[CurrentVertex];
	}
}
if (Result==CP_BACK) 
{
if (CurrentVertex!=0)
{
BackList[BackCounter++]=Poly->VertexList[CurrentVertex];
}
}
  
}
}// end for not onplane
}//end for loop



//OK THEN LETS BUILD THESE TWO POLYGONAL BAD BOYS

FrontSplit->NumberOfVertices=0;
BackSplit->NumberOfVertices=0;

for (loop=0;loop<FrontCounter;loop++)
{
FrontSplit->NumberOfVertices++;
FrontSplit->VertexList[loop]=FrontList[loop];
}
for (loop=0;loop<BackCounter;loop++)
{
BackSplit->NumberOfVertices++;
BackSplit->VertexList[loop]=BackList[loop];
}

BackSplit->NumberOfIndices=(BackSplit->NumberOfVertices-2)*3;
FrontSplit->NumberOfIndices=(FrontSplit->NumberOfVertices-2)*3;



// Calculate the indices


// Fill in the Indices
WORD v0,v1,v2;
for (loop=0;loop<FrontSplit->NumberOfIndices/3;loop++)
{
	if (loop==0) 
	{
		v0=0;
		v1=1;
		v2=2;
	}
	else
	{
	v1=v2;
	v2++;
	}
	
FrontSplit->Indices[loop*3]=v0;
FrontSplit->Indices[(loop*3)+1]=v1;
FrontSplit->Indices[(loop*3)+2]=v2;
}


for (loop=0;loop<BackSplit->NumberOfIndices/3;loop++)
{
	if (loop==0) 
	{
		v0=0;
		v1=1;
		v2=2;
	}
	else
	{
	v1=v2;
	v2++;
	}
	
BackSplit->Indices[loop*3]=v0;
BackSplit->Indices[(loop*3)+1]=v1;
BackSplit->Indices[(loop*3)+2]=v2;
}



D3DVECTOR edge1,edge2;
edge1=*(D3DVECTOR *)&FrontSplit->VertexList[FrontSplit->Indices[1]]-*(D3DVECTOR *)&FrontSplit->VertexList[FrontSplit->Indices[0]];
edge2=*(D3DVECTOR *)&FrontSplit->VertexList[FrontSplit->Indices[FrontSplit->NumberOfIndices-1]]-*(D3DVECTOR *)&FrontSplit->VertexList[FrontSplit->Indices[0]];
FrontSplit->Normal=CrossProduct(edge1,edge2);

FrontSplit->Normal=Normalize(FrontSplit->Normal);
edge1=*(D3DVECTOR *)&BackSplit->VertexList[BackSplit->Indices[1]]-*(D3DVECTOR *)&BackSplit->VertexList[BackSplit->Indices[0]];
edge2=*(D3DVECTOR *)&BackSplit->VertexList[BackSplit->Indices[BackSplit->NumberOfIndices-1]]-*(D3DVECTOR *)&BackSplit->VertexList[BackSplit->Indices[0]];
BackSplit->Normal=CrossProduct(edge1,edge2);
BackSplit->Normal=Normalize(BackSplit->Normal);


  }



  
  
  
  
  
  

  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  POLYGON * AddPolygon(POLYGON* Parent,D3DLVERTEX *Vertices,WORD NOV)
{
int loop;
POLYGON * Child=new POLYGON;

Child->NumberOfVertices=NOV;
Child->NumberOfIndices=(NOV-2)*3;
Child->Next=NULL;



for (loop=0;loop<NOV;loop++)
{
Child->VertexList[loop]=Vertices[loop];
}

//calculate indices
WORD v0,v1,v2;
for (loop=0;loop<Child->NumberOfIndices/3;loop++)
{
	
if (loop==0) 
	{
		v0=0;
		v1=1;
		v2=2;
	}
	else
	{
	v1=v2;
	v2++;
	}
	
Child->Indices[loop*3]=v0;
Child->Indices[(loop*3)+1]=v1;
Child->Indices[(loop*3)+2]=v2;
}

// generate polygon normal
D3DVECTOR * vec0=(D3DVECTOR *) &Child->VertexList[0];
D3DVECTOR * vec1=(D3DVECTOR *) &Child->VertexList[1];
D3DVECTOR * vec2=(D3DVECTOR *) &Child->VertexList[Child->NumberOfVertices-1];// the last vert


D3DVECTOR edge1=(*vec1)-(*vec0);
D3DVECTOR edge2=(*vec2)-(*vec0);
Child->Normal=CrossProduct(edge1,edge2);

 Child->Normal=Normalize(Child->Normal);


if (Parent!=NULL)
{
Parent->Next=Child;
}

return Child;
}


  

  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  














void UpdateViewpos()
{  
D3DMATRIX PitchMatrix, YawMatrix;// Well need a Matrix for pitch and another for yaw 

D3DUtil_SetRotationMatrix( YawMatrix, up_vector, Yaw );

D3DMath_VectorMatrixMultiply(look_vector, look_vector,YawMatrix);
D3DMath_VectorMatrixMultiply(right_vector,right_vector,YawMatrix);

look_vector=Normalize(look_vector);
right_vector=CrossProduct(up_vector,look_vector) ;
right_vector=Normalize(right_vector);
up_vector=CrossProduct(look_vector,right_vector);;
up_vector=Normalize(up_vector) ;

D3DMATRIX view;

D3DUtil_SetIdentityMatrix( view );// defined in d3dutil.h and d3dutil.cpp 
view._11 = right_vector.x; view._12 = up_vector.x; view._13 = look_vector.x;
view._21 = right_vector.y; view._22 = up_vector.y; view._23 = look_vector.y;
view._31 = right_vector.z; view._32 = up_vector.z; view._33 = look_vector.z;
view._41 =- DotProduct( position, right_vector ); // dot product defined in d3dtypes.h
view._42 =- DotProduct( position, up_vector );
view._43 =- DotProduct( position, look_vector );

lpDevice->SetTransform(D3DTRANSFORMSTATE_VIEW,&view); 
Yaw=0.0;	 
	
}
























 
 
 
 
 			
 
 
 
 
 POLYGON * SelectBestSplitter(POLYGON *PolyList)
 {
 POLYGON* Splitter=PolyList;
 POLYGON* CurrentPoly=NULL;
unsigned long BestScore=100000;
POLYGON * SelectedPoly=NULL; 
 


 while (Splitter!=NULL)
 {
	 CurrentPoly=PolyList;
	 unsigned long score,splits,backfaces,frontfaces;
	  score=splits=backfaces=frontfaces=0;
	 while (CurrentPoly!=NULL)
	{
		
	  
		if (CurrentPoly!=Splitter)
		{
		 int result=ClassifyPoly(Splitter,CurrentPoly);
				 switch ( result)
				 {
				 case CP_ONPLANE:
					 break;
				 case CP_FRONT:
					 frontfaces++;
					 break;
				 case CP_BACK:
					 backfaces++;
					 break;
				 case CP_SPANNING:
					 splits++;
					 break;
				 default:
					 break;
				 }// switch
		}// splitter and current are not the same
  
		CurrentPoly=CurrentPoly->Next;
	}// end while current poly


	
	 
	score=abs(frontfaces-backfaces)+(splits*4);
		if (score<BestScore)
		{
		 BestScore=score;
		SelectedPoly=Splitter;
		}
  
	Splitter=Splitter->Next;
 }// end while splitter == null	
 
 return SelectedPoly;
 }
   



 

 

































 
 bool LineOfSight (D3DVECTOR *Start,D3DVECTOR *End, NODE *Node)
{
float temp;
D3DVECTOR intersection;
if (Node->IsLeaf==true)
{
 return !Node->IsSolid;
}
int PointA=ClassifyPoint(Start,Node->Splitter);
 int PointB=ClassifyPoint(End,Node->Splitter);

 if (PointA==CP_ONPLANE && PointB==CP_ONPLANE)
 {
 	return LineOfSight(Start,End,Node->Front);
 }

 if (PointA==CP_FRONT && PointB==CP_BACK)
 {
  Get_Intersect (Start,End,(D3DVECTOR *) &Node->Splitter->VertexList[0],&Node->Splitter->Normal,&intersection,&temp);
 return LineOfSight(Start,&intersection,Node->Front) && LineOfSight(End,&intersection,Node->Back) ;
 
 }


  if (PointA==CP_BACK && PointB==CP_FRONT)
 {
  Get_Intersect (Start,End,(D3DVECTOR *) &Node->Splitter->VertexList[0],&Node->Splitter->Normal,&intersection,&temp);
 return LineOfSight(End,&intersection,Node->Front) && LineOfSight(Start,&intersection,Node->Back) ;
 
 }


  // if we get here one of the points is on the plane
 if (PointA==CP_FRONT || PointB==CP_FRONT)
 {
  return LineOfSight(Start,End,Node->Front);
 }
 else
 {
  return LineOfSight(Start,End,Node->Back);
 }

 return true;
}


 
 
 
 
 
 
 
 
 
 
 
 void DeleteBSPTree(NODE *Node)
{
if (Node->Back) DeleteBSPTree(Node->Back);
if (Node->Front) DeleteBSPTree(Node->Front);
if (Node->Splitter) delete Node->Splitter;
delete Node;


}